<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Task 32.50</title>
</head>

<body>
    <div class="container-fluid">
        <div class="text-center">
            <h2>Danh sách người dùng</h2>
        </div>
        <div class="form-group">
            <button id="btn-add-user" class="btn btn-success">Thêm Users</button>
        </div>
        <table id="user-table" class="table table-bordered table-striped table-hovers">
            <thead>
                <th>ID</th>
                <th>FIRSTNAME</th>
                <th>LASTNAME</th>
                <th>COUNTRY</th>
                <th>SUBJECT</th>
                <th> CUSTOMER TYPE</th>
                <th>REGISTER STATUS</th>
                <th>ACTION</th>
            </thead>
        </table>
    </div>
</body>
<script>
    $(document).ready(function () {
        onPageLoading()
        $("#user-table").on("click", ".btn-edit", function () {
            onBtnEditClick(this)
        })
        $("#user-table").on("click", ".btn-delete", function () {
            onBtnDeleteClick(this)
        })
        $("#btn-add-user").on("click", function () {
            onBtnAddUsers()
        })
    })

    function onPageLoading() {
        callApiAllUser()
    }
    // hàm thêm user
    function onBtnAddUsers(){
        window.location.href = "insertUser.html"
    }
    // hàm sửa user
    function onBtnEditClick(paramButton) {
        var vId = $(paramButton).data("userid")
        console.log("Id tương ứng là: " + vId)
        window.location.href = "updateUser.html" + "?id=" + vId
    }
    // hàm xóa user
    function onBtnDeleteClick(paramButton) {
        var vId = $(paramButton).data("userid")
        if(confirm("Bạn có muốn User " + vId + " này không ?" ) == true){
            
            callApiDeleteUser(vId)
        } 

    }
    function callApiAllUser() {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            success: function (paramOjb) {
                console.log(paramOjb)
                loadDataToTable(paramOjb);
            },
            error: function (paramError) {
                console.log(paramError.state)
            }

        })
    }
    function  callApiDeleteUser(paramUserID) {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramUserID ,
            type: "DELETE",
            success: function (paramOjb) {
                console.log(paramOjb)
                alert("Xóa User " + paramUserID + " thành công")
            },
            error: function (paramError) {
                alert("Xóa User " + paramUserID + " thất bại")

                console.log(paramError.state)
            }

        })
    }

    function loadDataToTable(paramOjb) {
        $("<tbody/>").appendTo("#user-table")
        var vTbody = $("#user-table tbody")
        for (var bI = 0; bI < paramOjb.length; bI++) {
            var bNewRow = $("<tr/>").appendTo(vTbody)
            $("<td>", { html: paramOjb[bI].id }).appendTo(bNewRow)
            $("<td>", { html: paramOjb[bI].firstname }).appendTo(bNewRow)
            $("<td>", { html: paramOjb[bI].lastname }).appendTo(bNewRow)
            $("<td>", { html: paramOjb[bI].country }).appendTo(bNewRow)
            $("<td>", { html: paramOjb[bI].subject }).appendTo(bNewRow)
            $("<td>", { html: paramOjb[bI].customerType }).appendTo(bNewRow)
            $("<td>", { html: paramOjb[bI].registerStatus }).appendTo(bNewRow)

            var bColAction = $("<td/>").appendTo(bNewRow)
            // thêm nút button
            var bButtonEdit = $("<button/>", {
                html: "Sửa",
                class: "btn btn-primary btn-edit"
            }).data("userid", paramOjb[bI].id)
                .appendTo(bColAction)

            var bButtonDelete = $("<button/>", {
                html: "Xóa",
                class: "btn btn-danger btn-delete"
            })
                .data("userid", paramOjb[bI].id)
                .appendTo(bColAction)

        }
    }
    
</script>

</html>